// ----------------------------------------------------------------------------
//
// rt_heap.i
// RT++ garbage collected heap
//
// $Id: rt_heap.i,v 1.4 1996/04/04 07:05:45 schreine Exp $
// (C) 1996 Wolfgang Schreiner <Wolfgang.Schreiner@risc.uni-linz.ac.at>
//
// ----------------------------------------------------------------------------
#ifndef RT_HEAP_I
#define RT_HEAP_I

// ----------------------------------------------------------------------------
//
// link thread stack into list for mark phase of garbage collection
//
// ----------------------------------------------------------------------------
inline void 
Heap::push(Stack *shadow)
{
  mutex_gc.lock();
  if (shadow->gc)
    {
      mutex_gc.unlock();
      return;
    }
  shadow->gc = 1;
  shadow->next = (Stack*)stacks;
  stacks = shadow;
  mutex_gc.unlock();
}

#endif
// ----------------------------------------------------------------------------
// end of rt_heap.i
// ----------------------------------------------------------------------------
// Local Variables: ***
// mode: C++ ***
// End: ***
