// ----------------------------------------------------------------------------
//
// rt_shared.h
// RT++ shared memory system
//
// $Id: rt_shared.h,v 1.11 1996/02/29 19:11:18 ws Exp $
// (C) 1996 Wolfgang Schreiner <Wolfgang.Schreiner@risc.uni-linz.ac.at>
//
// ----------------------------------------------------------------------------
#ifndef RT_SHARED_H
#define RT_SHARED_H

// initialize shared memory with <size> bytes
void shm_init(int size);

// shutdown shared memory
// must be called before program exit
void shm_shut(void);

// return current size of shared memory
int shm_size(void);

// allocate shared memory block of <n> bytes and return a pointer to it
// abort program, if requested block is not available
void* shm_alloc(int n);

// allocate shared memory block of <n> bytes and return a pointer to it
// return 0, if requested block is not available
void* shm_alloc_test(int n);

// free previously allocated shared memory at address <p>
void shm_free(void *p);

#endif
// ----------------------------------------------------------------------------
// end of rt_shared.h
// ----------------------------------------------------------------------------
// Local Variables: ***
// mode: C++ ***
// End: ***
