// ----------------------------------------------------------------------------
//
// rt_shared.i
// RT++ shared memory system
//
// $Id: rt_shared.i,v 1.2 1996/04/03 08:33:03 ws Exp $
// (C) 1996 Wolfgang Schreiner <Wolfgang.Schreiner@risc.uni-linz.ac.at>
//
// ----------------------------------------------------------------------------
#ifndef RT_SHARED_I
#define RT_SHARED_I

// ----------------------------------------------------------------------------
//
// return processor alignment
//
// ----------------------------------------------------------------------------
inline static int
rt_alignment(void)
{
  return(RT_ALIGNMENT);
}

// ----------------------------------------------------------------------------
//
// align to processor requirements
// this assumes that rt_alignment() is a power of two!!!
//
// ----------------------------------------------------------------------------
inline static void*
rt_align(void *p)
{
  unsigned long a = rt_alignment()-1;
  return((void*)((((unsigned long)p) + a) & ~a));
}

// ----------------------------------------------------------------------------
//
// align to processor requirements DOWNWARDS
// this assumes that rt_alignment() is a power of two!!!
//
// ----------------------------------------------------------------------------
inline static void*
rt_aligndown(void *p)
{
  unsigned long a = rt_alignment()-1;
  return((void*)(((unsigned long)p) & ~a));
}

#endif
// ----------------------------------------------------------------------------
// end of rt_shared.i
// ----------------------------------------------------------------------------
// Local Variables: ***
// mode: C++ ***
// End: ***
