// ----------------------------------------------------------------------------
//
// lists.cc
// test of RT++ lists and garbage collection
//
// $Id: lists.cc,v 1.3 1996/04/02 08:45:07 schreine Exp $
// (C) 1996 Wolfgang Schreiner <Wolfgang.Schreiner@risc.uni-linz.ac.at>
//
// ----------------------------------------------------------------------------

#include <rt++.h>

Atom(int);
Ref(List<int>);

// ----------------------------------------------------------------------------
//
// create iteratively list of lists
// keep last array for consistency check after gc
//
// ----------------------------------------------------------------------------
int lists(int, char *[])
{
  List< List<int> > s;
  int c = 0;
  for (int k=0; k < 1000; k++) 
    {
      List<int> t;
      int n = rand()%100;
      for (int i = 0; i < n; i++)
	{
	  t.cons(n-i-1, t);
	}
      c++;
      if (c == 100)
	{
	  c = 0;
	  s.nil();
	}
      else
	{
	  s.cons(t, s);
	}
      List< List<int> > u = s;
      while(!Null(u))
	{
	  List<int> v = Head(u);
	  int j = 0;
	  while (!Null(v))
	    {
	      if (Head(v) != j) rt_abort("gc error\n");
	      j++;
	      v.tail();
	    }
	  u.tail();
	}
    }
  return(0);
}       

void init(RT_Argument *rt_arg, int argc, char *argv[]);

int main(int argc, char *argv[]) 
{
  RT_Argument rt_arg;
  init(&rt_arg, argc, argv);
  exit(rt_main(lists, 1, argv, rt_arg, 0));
}

// ----------------------------------------------------------------------------
// end of lists.cc
// ----------------------------------------------------------------------------
// Local Variables: ***
// mode: C++ ***
// End: ***
