// ----------------------------------------------------------------------------
//
// tbags.cc
// test of RT++ thread bags and garbage collection
//
// $Id: tbags.cc,v 1.4 1996/04/02 08:45:17 schreine Exp $
// (C) 1996 Wolfgang Schreiner <Wolfgang.Schreiner@risc.uni-linz.ac.at>
//
// ----------------------------------------------------------------------------

#include <rt++.h>

Atom(int);
Ref(ThreadBag<int>);
ThreadRes(int);
ThreadArg1(TB1, int, ThreadBag<int>);
ThreadBagRes(int);

// ----------------------------------------------------------------------------
//
// create list and check for consistency
//
// ----------------------------------------------------------------------------
int list(int n)
{
  List<int> l;
  int i;
  for (i = 0; i < n; i++)
    { 
      for (int j = 0; j < 1000; j++) {}
      l.cons(i, l);
    }
  while (!Null(l))
    {
      i--;
      if (Head(l) != i) rt_abort("elem error");
      l.tail();
    }
  if (i!=0) rt_abort("count error");
  return(1);
}

// ----------------------------------------------------------------------------
//
// collect bag results
//
// ----------------------------------------------------------------------------
int waiter(ThreadBag<int> bag)
{
  int r = 0;
  int i = 0;
  while (1)
    {
      int done;
      int x = Wait(bag, i, &done);
      if (!done) break;
      r += x;
      i++;
    }
  return(r);
}

// ----------------------------------------------------------------------------
//
// create bag and bag collector
//
// ----------------------------------------------------------------------------
int tbags(int, char *[])
{
  cout << "Start\n";
  ThreadBag<int> bag;
  bag.open();
  Thread1<int, ThreadBag<int> > t(waiter, bag);
  for (int i = 0; i < 20; i++)
    {
      ThreadBag1<int,int>(bag, list, rand()%8000);
    }
  bag->close();
  cout << "Result " << Wait(t) << "\n";
  return(0);
}

void init(RT_Argument *rt_arg, int argc, char *argv[]);

int main(int argc, char *argv[]) 
{
  RT_Argument rt_arg;
  init(&rt_arg, argc, argv);
  exit(rt_main(tbags, 1, argv, rt_arg, 0));
}

// ----------------------------------------------------------------------------
// end of tbags.cc
// ----------------------------------------------------------------------------
// Local Variables: ***
// mode: C++ ***
// End: ***
