// ----------------------------------------------------------------------------
//
// template.cc
// test of RT++ template instantiations
//
// $Id: template.cc,v 1.2 1996/04/02 08:45:18 schreine Exp $
// (C) 1996 Wolfgang Schreiner <Wolfgang.Schreiner@risc.uni-linz.ac.at>
//
// ----------------------------------------------------------------------------

#include <rt++.h>

Atom(int);
Atom(double);
ThreadRes(double);
ThreadArg0(A0, double);
ThreadArg1(A1, double, int);
ThreadArg2(A2, double, int, int);
ThreadArg3(A3, double, int, int, int);
ThreadArg4(A4, double, int, int, int, int);
ThreadBagRes(double);

double f0(void)
{
  return(1);
}

double f1(int x)
{
  return(x);
}

double f2(int x, int)
{
  return(x);
}

double f3(int x, int, int)
{
  return(x);
}

double f4(int x, int, int, int)
{
  return(x);
}

// ----------------------------------------------------------------------------
//
// create thread and thread bag templates for each number of arguments
//
// ----------------------------------------------------------------------------
int templ(int, char *[])
{
  double r;
  Thread0<double> t0(f0);
  Thread1<double,int> t1(f1, 1);
  Thread2<double,int, int> t2(f2, 1, 0);
  Thread3<double,int, int, int> t3(f3, 1, 0, 0);
  Thread4<double,int, int, int, int> t4(f4, 1, 0, 0, 0);
  r = Wait(t0) + Wait(t1) + Wait(t2) + Wait(t3) + Wait(t4);
  cout << "Result " << r << "\n";
  r = 0;
  Thread<double> t;
  t = t0; r += Wait(t);
  t = t1; r += Wait(t);
  t = t2; r += Wait(t);
  t = t3; r += Wait(t);
  t = t4; r += Wait(t);
  cout << "Result " << r << "\n";
  ThreadBag<double> bag(5);
  ThreadBag0<double>(bag, f0);
  ThreadBag1<double, int>(bag, f1, 1);
  ThreadBag2<double, int, int>(bag, f2, 1, 0);
  ThreadBag3<double, int, int, int>(bag, f3, 1, 0, 0);
  ThreadBag4<double, int, int, int, int>(bag, f4, 1, 0, 0, 0);
  r = Wait(bag, 0) + Wait(bag, 1) + Wait(bag, 2) + Wait(bag, 3) + Wait(bag, 4);
  cout << "Result " << r << "\n";
  return(0);
}

void init(RT_Argument *rt_arg, int argc, char *argv[]);

int main(int argc, char *argv[]) 
{
  RT_Argument rt_arg;
  init(&rt_arg, argc, argv);
  exit(rt_main(templ, 1, argv, rt_arg, 0));
}

// ----------------------------------------------------------------------------
// end of template.cc
// ----------------------------------------------------------------------------
// Local Variables: ***
// mode: C++ ***
// End: ***
